#pragma once

#include "mapped_file_object_interface.h"
#include "pager.h"

/* A pager abstraction for a file. */

class FilePager : public Pager, public MappedFileObject
{
public:
    fileid_t fileid;

    explicit FilePager(fileid_t fileid, PageMapper *mapper);

    virtual long map(unsigned long offset, l4_addr_t hot_spot, unsigned long flags, l4_snd_fpage_t *region)
    { return Pager::map(offset, hot_spot, flags, region); }

    virtual long mmap(size_t position, size_t length, size_t *start_pos, size_t *end_pos, size_t *data_end);
};

// vim: tabstop=4 expandtab shiftwidth=4
